import QtQuick 1.1
import com.nokia.meego 1.0

Page {
    id: categoriesPage

    anchors.fill: parent

    TopBar {
        id: nk_banner
        anchors.top: parent.top
    }

    CategoriesListView {
        id: categoriesNewsView
        anchors.top: nk_banner.bottom
        anchors.right: parent.right
        anchors.bottom: parent.bottom
        anchors.left: parent.left

        Component.onCompleted: getCategories()

        onItemClicked: {
            if(!categoriesPage.pageStack.busy) {
                // Show the subcategories for the selected category

                var subCategoriesPage =
                        categoriesPage.pageStack.push(Qt.resolvedUrl("SubcategoriesPage.qml"),
                                                  { parentCategoryId: catId,
                                                    parentCategoryTitle: catTitle,
                                                    showAllNewsPlaceholder: true
                                                  });

                subCategoriesPage.subcategoriesNewsView.getSubcategories(catId);
            }
        }
    }

    tools: ToolBarLayout {
        id: toolBarLayoutDescription

        ToolIcon {
            iconId: "toolbar-back"
            
            anchors.left: (parent === undefined) ? undefined : parent.left
            onClicked: {
                if(busyIndicator)
                    busyIndicator.opacity = 0;
                appMenu.close();
                categoriesPage.pageStack.pop();
            }
        }

        ToolIcon {
            iconId: "toolbar-view-menu"
            
            anchors.right: (parent === undefined) ? undefined : parent.right
            onClicked: (appMenu.status == DialogStatus.Closed) ? appMenu.open() : appMenu.close()
        }
    }
}
