import QtQuick 1.1
import com.nokia.meego 1.0

Page {
    id: followUsPage

    ListModel {
        id: followUsModel

        ListElement {
            title: "Forum"
            image: "qrc:images/forum.png"
            linkUrl: "http://www.nokioteca.net/home/forum/"
            description: "Unisciti alla nostra community per discutere e risolvere i tuoi dubbi"
        }

        ListElement {
            title: "Facebook"
            image: "qrc:images/facebook.png"
            linkUrl: "http://www.facebook.com/Nokioteca"
            description: "Segui e commenta tutti gli articoli nella nostra pagina"
        }

        ListElement {
            title: "Twitter"
            image: "qrc:images/twitter.png"
            linkUrl: "http://twitter.com/nokioteca"
            description: "Tutte le notizie del blog a portata di tweet"
        }

        ListElement {
            title: "Youtube"
            image: "qrc:images/youtube.png"
            linkUrl: "http://www.youtube.com/user/Nokioteca"
            description: "Tutti i nostri video e le nostre recensioni a portata di click"
        }
    }

    Component {
        id: followUsDelegate

        Item {
            width: parent.width
            height: followUsTitleLabel.height + followUsDescriptionLabel.height + 20

            Image {
                id: linkImage
                anchors {
                    left: parent.left
                    top: parent.top
                }
                width: 32
                fillMode: Image.PreserveAspectFit
                source: image
            }

            Label {
                id: followUsTitleLabel
                anchors {
                    verticalCenter: linkImage.verticalCenter
                    left: linkImage.right
                    right: parent.right
                    leftMargin: settings.largeMargin
                    rightMargin: settings.smallMargin
                }

                wrapMode: Text.WordWrap
                font.pixelSize: settings.fontSizeL + settings.fontCorrection
                font.bold: true
                text: title
            }

            Label {
                id: followUsDescriptionLabel
                anchors {
                    top: followUsTitleLabel.bottom
                    left: linkImage.right
                    right: parent.right
                    leftMargin: settings.largeMargin
                    rightMargin: settings.smallMargin
                }

                wrapMode: Text.WordWrap
                font.pixelSize: settings.fontSizeL + settings.fontCorrection
                text: description
            }

            MouseArea {
                anchors.fill: parent
                onClicked: Qt.openUrlExternally(linkUrl)
            }
        }
    }

    Label {
        id: followUsLabel
        anchors {
            top: parent.top
            left: parent.left
            right: parent.right
            leftMargin: settings.mediumMargin
            topMargin: settings.mediumMargin
        }

        clip: true
        font.pixelSize: settings.fontSizeXXL + settings.fontCorrection
        verticalAlignment: Text.AlignVCenter

        text: "Social:"
    }

    ListView {
        id: followUsList
        anchors{
            top: followUsLabel.bottom
            bottom: parent.bottom
            left: parent.left
            right: parent.right
            leftMargin: settings.hugeMargin
            rightMargin: settings.smallMargin
            topMargin: settings.mediumMargin
        }

        clip: true

        model: followUsModel
        delegate: followUsDelegate

        interactive: contentHeight > height
    }


    tools: ToolBarLayout {
        id: toolBarLayoutDescription

        ToolIcon {
            iconId: "toolbar-back"
            
            anchors.left: (parent === undefined) ? undefined : parent.left
            onClicked: {
                if(busyIndicator)
                    busyIndicator.opacity = 0;
                smallMenu.close();
                followUsPage.pageStack.pop();
            }
        }

        ToolIcon {
            iconId: "toolbar-view-menu"
            
            anchors.right: (parent === undefined) ? undefined : parent.right
            onClicked: (smallMenu.status == DialogStatus.Closed) ? smallMenu.open() : smallMenu.close()
        }
    }
}
