import QtQuick 1.1

Item {
    id: root

    // Signalled, when opacity reaches 0.
    signal dismissed

    Loader {
        id: splashLoader

        anchors.fill: parent

        onLoaded: item.showAnimation = true
    }

    Behavior on opacity {
        SequentialAnimation {
            NumberAnimation { duration: 800 }
            ScriptAction { script: splashLoader.source = "" }
            ScriptAction { script: dismissed() }
        }
    }

    states: [
        State {
            name: "NORMAL"
            when: !nokioteca.isHolidaysPeriod()
            PropertyChanges {
                target: splashLoader
                source: Qt.resolvedUrl("SplashScreen.qml")
            }
        },
        State {
            name: "HOLIDAYS"
            when: nokioteca.isHolidaysPeriod()
            PropertyChanges {
                target: splashLoader
                source: Qt.resolvedUrl("SplashScreen_h.qml")
            }
        }
    ]
}
