import QtQuick 1.1
import com.nokia.meego 1.0

Page {
    id: newsPage

    property bool searchEnabled: settings.searchUniversalEnabled
    property bool isWindowsteca: false
    
    TopBar {
        id: nk_banner
        anchors.top: parent.top
    }

    NewsListView {
        id: latestNewsView
        anchors {
            top: nk_banner.bottom
            right: parent.right
            bottom: parent.bottom
            left: parent.left
        }

        Component.onCompleted: getNews()

        onItemClicked: {
            if(!newsPage.pageStack.busy) {
                // Show the details view for the selected news
                var detailsPage =
                        newsPage.pageStack.push(Qt.resolvedUrl("SingleNewsPage.qml"),
                                                { newsId: id, commentsCount: comments }
                        );
                detailsPage.fetchDetails(id);
            }
        }
    }

    tools: ToolBarLayout {
        id: toolBarLayout

        ToolIcon {
            iconId: {
                if(window.pageStack.depth <= 1)
                    return "toolbar-close"
                else
                    return "toolbar-back";
            }
            
            onClicked: {
                appMenu.close();
                if(window.pageStack.depth <= 1)
                    Qt.quit();
                else
                    window.pageStack.pop()
            }
        }

        ToolIcon {
            iconId: "toolbar-list"
            
            onClicked: {
                if(!pageStack.busy) {
                    appMenu.close();
                    pageStack.push(Qt.resolvedUrl("CategoriesPage.qml"));
                }
            }
        }

        ToolIcon {
            iconId: "toolbar-refresh"
            
            onClicked: { appMenu.close(); latestNewsView.reload() }
        }

        ToolIcon {
            iconSource: "qrc:images/windowsteca" + (window.platformWhite ? "_w" : "") + ".svg"
            
            onClicked: {
                if(!pageStack.busy) {
                    appMenu.close();
                    pageStack.push(Qt.resolvedUrl("WindowstecaNewsPage.qml"));
                }
            }
        }
        
        ToolIcon {
            iconId: "toolbar-view-menu"
            
            anchors.right: (parent === undefined) ? undefined : parent.right
            onClicked: (appMenu.status == DialogStatus.Closed) ? appMenu.open() : appMenu.close()
        }
    }
}
