import QtQuick 1.1
import com.nokia.meego 1.0

Page {
    id: searchResultsPage

    property string searchedKeyword: ""
    property bool isWindowsteca: false
    property bool searchEnabled: settings.searchUniversalEnabled

    property alias searchResultsView: searchResultsView

    TopBar {
        id: nk_banner
        anchors.top: parent.top
        isWindowsteca: parent.isWindowsteca
    }

    Label {
        id: searchInfo

        anchors {
            top: nk_banner.bottom
            right: parent.right
            left: parent.left
        }
     
        wrapMode: Text.WordWrap
        font.pixelSize: settings.fontSizeL + settings.fontCorrection
        text: "Risultati della ricerca per \"<strong>" + searchedKeyword + "</strong>\":";
    }

    Rectangle {
        id: separatorLine

        anchors {
            top: searchInfo.bottom
            right: parent.right
            left: parent.left
            topMargin: settings.smallMargin
            leftMargin: settings.smallMargin
            rightMargin: settings.smallMargin
        }

        border.color: window.platformWhite ? settings.darkColor : settings.lightColor
        height: 2
    }

    NewsListView {
        id: searchResultsView
        anchors {
            top: separatorLine.bottom
            right: parent.right
            bottom: parent.bottom
            left: parent.left
        }

        isWindowsteca: parent.isWindowsteca
        
        onItemClicked: {
            if(!searchResultsPage.pageStack.busy) {
                var detailsPage =
                        searchResultsPage.pageStack.push(Qt.resolvedUrl("SingleNewsPage.qml"),
                                                  { newsId: id, commentsCount: comments, isWindowsteca: isWindowsteca });
                detailsPage.fetchDetails(id);
            }

        }
    }

    tools: ToolBarLayout {
        id: toolBarLayoutDescription

        ToolIcon {
            iconId: "toolbar-back"
            
            anchors.left: (parent === undefined) ? undefined : parent.left
            onClicked: {
                if(busyIndicator)
                    busyIndicator.opacity = 0;
                appMenu.close();
                searchResultsPage.pageStack.pop();
            }
        }

        ToolIcon {
            iconId: "toolbar-view-menu"
            
            anchors.right: (parent === undefined) ? undefined : parent.right
            onClicked: (appMenu.status == DialogStatus.Closed) ? appMenu.open() : appMenu.close()
        }
    }
}
