import QtQuick 1.1
import com.nokia.meego 1.0

Page {
    id: singleCategoryNewsPage

    property string selectedCategoryId
    property string selectedCategoryTitle

    property alias byCategoryNewsView: byCategoryNewsView

    TopBar {
        id: nk_banner
        anchors.top: parent.top
    }

    Label {
        id: categoryName

        anchors {
            top: nk_banner.bottom
            right: parent.right
            left: parent.left
        }
     
        wrapMode: Text.WordWrap
        font.pixelSize: settings.fontSizeL + settings.fontCorrection
        text: "Articoli nella categoria:<br/>\"<strong>" + selectedCategoryTitle + "</strong>\":";
    }

    Rectangle {
        id: separatorLine

        anchors {
            top: categoryName.bottom
            right: parent.right
            left: parent.left
            topMargin: settings.smallMargin
            leftMargin: settings.smallMargin
            rightMargin: settings.smallMargin
        }

        border.color: window.platformWhite ? settings.darkColor : settings.lightColor
        height: 2
    }

    NewsListView {
        id: byCategoryNewsView
        anchors {
            top: separatorLine.bottom
            right: parent.right
            bottom: parent.bottom
            left: parent.left
        }

        onItemClicked: {
            if(!singleCategoryNewsPage.pageStack.busy) {
                var detailsPage =
                        singleCategoryNewsPage.pageStack.push(Qt.resolvedUrl("SingleNewsPage.qml"),
                                                  { newsId: id, commentsCount: comments });
                detailsPage.fetchDetails(id);
            }

        }
    }

    tools: ToolBarLayout {
        id: toolBarLayoutDescription

        ToolIcon {
            iconId: "toolbar-back"
            
            anchors.left: (parent === undefined) ? undefined : parent.left
            onClicked: {
                if(busyIndicator)
                    busyIndicator.opacity = 0;
                appMenu.close();
                singleCategoryNewsPage.pageStack.pop();
            }
        }

        ToolIcon {
            iconId: "toolbar-view-menu"
            
            anchors.right: (parent === undefined) ? undefined : parent.right
            onClicked: (appMenu.status == DialogStatus.Closed) ? appMenu.open() : appMenu.close()
        }
    }
}
