import QtQuick 1.1

Item {
    id: splashScreen

    property bool showAnimation: false

    z: 150

    Rectangle {
        color: "#1D3652"
        anchors.fill: parent
    }

    Item {
        anchors {
            top: parent.top
            right: parent.right
            rightMargin: 12
            topMargin: 12
        }
        width: 30
        height: 30

        visible: splashScreen.opacity == 1

        Image {
            anchors.centerIn: parent
            fillMode: Image.PreserveAspectFit
            source: "qrc:images/close.svg"
            sourceSize.height: parent.height - 10
            smooth: true
        }

        MouseArea {
            anchors.fill: parent
            onClicked: Qt.quit()
        }
    }

    Item {
        id: appLogo
        anchors.centerIn: parent
        height: childrenRect.height

        Image {
            id: appIcon
            anchors.horizontalCenter: parent.horizontalCenter
            sourceSize.width: 60
            fillMode: Image.PreserveAspectFit
            smooth: true
            source: "qrc:images/nk_logo.png"
        }

        Image {
            id: appName
            anchors.topMargin: 10
            anchors.top: appIcon.bottom
            anchors.horizontalCenter: parent.horizontalCenter
            source: "qrc:images/app_banner.png"
        }
    }

    Image {
        anchors {
            top: appLogo.bottom
            topMargin: splashScreen.width > splashScreen.height ? 30 : 50
            horizontalCenter: parent.horizontalCenter
        }

        scale: 0.8

        source: "qrc:images/loadingapp.png"
        visible: showAnimation && splashScreen.opacity == 1

        NumberAnimation on rotation {
            running: visible
            from: 0
            to: 360
            loops: Animation.Infinite
            duration: 1200
        }
    }

    Text {
        anchors {
            bottom: parent.bottom
            right: parent.right
            bottomMargin: 5
            rightMargin: 5
        }
        color: "#FFFFFF"
        font.pixelSize: 12
        text: "v" + nokiotecaAppVersion
    }
}
