import QtQuick 1.1
import com.nokia.meego 1.0

Page {
    id: subCategoriesPage
    property int parentCategoryId
    property string parentCategoryTitle
    property alias subcategoriesNewsView: subcategoriesNewsView
    property alias showAllNewsPlaceholder: subcategoriesNewsView.showAllNewsPlaceholder

    TopBar {
        id: nk_banner
        anchors.top: parent.top
    }

    CategoriesListView {
        id: subcategoriesNewsView
        anchors.top: nk_banner.bottom
        anchors.right: parent.right
        anchors.bottom: parent.bottom
        anchors.left: parent.left

        onItemClicked: {
            if(!subCategoriesPage.pageStack.busy) {
                // Show the news for the selected category

                var singleCategoryNewsPage;
                if(catId === -2) {
                    singleCategoryNewsPage = subCategoriesPage.pageStack.replace(Qt.resolvedUrl("SingleCategoryNewsPage.qml"),
                                                  { selectedCategoryId: parentCategoryId,
                                                    selectedCategoryTitle: parentCategoryTitle
                                                  });
                    singleCategoryNewsPage.byCategoryNewsView.getNewsByCategory(parentCategoryId);
                    return;
                }
                if(catId === -1) {
                    singleCategoryNewsPage = subCategoriesPage.pageStack.push(Qt.resolvedUrl("SingleCategoryNewsPage.qml"),
                                                  { selectedCategoryId: parentCategoryId,
                                                    selectedCategoryTitle: parentCategoryTitle
                                                  });
                    singleCategoryNewsPage.byCategoryNewsView.getNewsByCategory(parentCategoryId);
                    return;
                }

                singleCategoryNewsPage = subCategoriesPage.pageStack.push(Qt.resolvedUrl("SingleCategoryNewsPage.qml"),
                                              { selectedCategoryId: catId,
                                                selectedCategoryTitle: parentCategoryTitle + " | " + catTitle
                                              });
                singleCategoryNewsPage.byCategoryNewsView.getNewsByCategory(catId);

            }
        }
    }

    tools: ToolBarLayout {
        id: toolBarLayoutDescription

        ToolIcon {
            iconId: "toolbar-back"
            
            anchors.left: (parent === undefined) ? undefined : parent.left
            onClicked: {
                if(busyIndicator)
                    busyIndicator.opacity = 0;
                appMenu.close();
                subCategoriesPage.pageStack.pop();
            }
        }

        ToolIcon {
            iconId: "toolbar-view-menu"
            
            anchors.right: (parent === undefined) ? undefined : parent.right
            onClicked: (appMenu.status == DialogStatus.Closed) ? appMenu.open() : appMenu.close()
        }
    }
}
