import QtQuick 1.1

Item {
    property bool isWindowsteca: false
    
    height: 75
    width: parent.width

    Rectangle {
        color: (isWindowsteca ? "white" : settings.nokiotecaBlue)

        anchors {
            verticalCenter: parent.verticalCenter
            fill: parent
        }

        Image {
            id: logo
            x: 10
            anchors.verticalCenter: parent.verticalCenter
            width: 45
            fillMode: Image.PreserveAspectFit
            smooth: true
            source: (isWindowsteca ? "qrc:images/wk_logo.png" : "qrc:images/nk_logo.png")
        }

        Image {
            id: logo_name
            anchors {
                left: logo.right
                leftMargin: settings.mediumMargin
                verticalCenter: parent.verticalCenter
            }
            smooth: true
            source: (isWindowsteca ? "qrc:images/wk_name.png" : "qrc:images/nk_name.png")
        }
    }

    MouseArea {
        anchors.fill: parent

        enabled: !isShowingSplashScreen
        
        onClicked: Qt.openUrlExternally(isWindowsteca ? nokioteca.getWindowstecaBlogUrl() : nokioteca.getBlogUrl())
    }
}
