import QtQuick 1.1

ListModel {
    id: root
    default property alias roles: xmlListModel.roles
    property alias source: xmlListModel.source
    property alias query: xmlListModel.query
    property alias namespaceDeclarations: xmlListModel.namespaceDeclarations

    property alias status: xmlListModel.status

    property bool reloadItems: false

    function push(item) {
        append(item);
    }

    function errorString() {
        return xmlListModel.errorString();
    }

    function reload(url) {
        root.clear();
        if(source == url) {
            xmlListModel.reload();
        }
        else
            source = url;
    }

    property variant __xmlListModel: XmlListModel {
        id: xmlListModel

        property variant keys: []

        function appendItem(index, count) {
            for(var i = 0; i < count; i++) {
                var item = get(i + index);
                    push(item);
            }
        }

        onItemsInserted: {
            appendItem(index, count);
        }

        onStatusChanged: {
            if(status === XmlListModel.Ready && root.count < xmlListModel.count) {
                appendItem(0, count);
            }
        }
    }

    Component.onCompleted: {
        var keys = new Array()
        for(var i = 0; i < roles.length; i++) {
            if(roles[i].isKey) {
                keys.push(roles[i].name);
            }
        }
        xmlListModel.keys = keys;
    }
}
