import QtQuick 1.1
import com.nokia.meego 1.0

Page {
    id: windowstecaNewsPage

    property bool searchEnabled: settings.searchUniversalEnabled
    property bool isWindowsteca: true
    
    TopBar {
        id: wk_banner
        anchors.top: parent.top
        isWindowsteca: true
    }

    NewsListView {
        id: latestWindowstecaNewsView
        anchors {
            top: wk_banner.bottom
            right: parent.right
            bottom: parent.bottom
            left: parent.left
        }

        isWindowsteca: true

        Component.onCompleted: getNews()

        onItemClicked: {
            if(!windowstecaNewsPage.pageStack.busy) {
                // Show the details view for the selected news
                var detailsPage =
                        windowstecaNewsPage.pageStack.push(Qt.resolvedUrl("SingleNewsPage.qml"),
                                                { newsId: id, commentsCount: comments, isWindowsteca: true }
                        );
                detailsPage.fetchDetails(id);
            }
        }
    }

    tools: ToolBarLayout {
        id: toolBarLayout

        ToolIcon {
            iconId: "toolbar-back";

            onClicked: { appMenu.close(); window.pageStack.pop() }
        }

        ToolIcon {
            iconId: "toolbar-refresh"

            onClicked: { appMenu.close(); latestWindowstecaNewsView.reload() }
        }

        ToolIcon {
            iconId: "toolbar-view-menu"

            anchors.right: (parent === undefined) ? undefined : parent.right
            onClicked: (appMenu.status == DialogStatus.Closed) ? appMenu.open() : appMenu.close()
        }
    }
}
