Qt.include("settings.js")
Qt.include("ajax.js")

var accessToken = "";
var newsToShare = "";
var newsToShareTitle = "";
var newsToShareThumb = "";
var newsFromWindowsteca = false;

function resetInMemoryToken() {
    accessToken = "";
}

function setAccessToken(token) {
    accessToken = token;
}

function shareNewsOnFacebook(newsId, newsTitle, newsThumb, isWindowsteca) {
    newsToShare = newsId;
    newsToShareTitle = newsTitle;
    newsToShareThumb = newsThumb;
    newsFromWindowsteca = isWindowsteca;
    accessToken = getFacebookToken();
    if(accessToken.length == 0) {
        return false;
    }
    shareLinkOnFacebook();
    return true;
}

function getFacebookAccessToken(tokenUrl) {
    var code = parseParameter(tokenUrl, "code");
    var redUrl = "https://graph.facebook.com/oauth/access_token?client_id=" + nokioteca.getFacebookAppId() +
            "&redirect_uri=" + nokioteca.getSocialCallbackUrl() +//encodeURIComponent(nokioteca.getSocialCallbackUrl()) +
            "&client_secret=" + nokioteca.getFacebookAppSecret() +
            "&code=" + code;
    var req = createXMLHttpRequest();
    
    loadXMLDocSync(req, redUrl, parseAccessToken);
}

function shareLinkOnFacebook() {
    var url = "https://graph.facebook.com/me/feed?" + accessToken + "&message=" +
            encodeURIComponent("Ho letto questo articolo su " +
                               (newsFromWindowsteca ? "www.windowsteca.net:" : "www.nokioteca.net:")) +
            "&link=" + encodeURIComponent(
                newsFromWindowsteca ? nokioteca.getWindowstecaBlogNewsUrl(newsToShare) : nokioteca.getBlogNewsUrl(newsToShare)
            ) +
            "&description=" + encodeURIComponent(newsToShareTitle) +
            "&picture=" + encodeURIComponent(newsToShareThumb);

    if(busyIndicator)
        busyIndicator.opacity = 0;
    var req = createXMLHttpRequest();
    loadXMLDoc(req, url, parseShareLink, "");
}

function parseShareLink(responseXML, responseText) {
    if(responseText) {
        infoBanner.text = "Articolo condiviso correttamente"
        infoBanner.iconSource = "qrc:images/facebook.png"
        infoBanner.show();
        return;
    }

    setAccessToken("");
    setFacebookToken("");

    var authDialog = newsDetailPage.getAuthenticationDialog("Facebook");
    authDialog.visible = true;
    authDialog.loadFacebookLoginPage();
    return;
}

function parseAccessToken(responseXML, responseText) {
    accessToken = "access_token=" + parseParameter(responseText, "access_token");
    setFacebookToken(accessToken);
    shareLinkOnFacebook();
}

function parseParameter(url, parameter) {
    var parameterIndex = url.indexOf(parameter);
    if(parameterIndex < 0) {
        // We didn't find parameter
        return "";
    }
    var equalIndex = url.indexOf("=", parameterIndex);
    if(equalIndex < 0) {
        return "";
    }
    var value = "";
    var nextIndex = url.indexOf("&", equalIndex + 1);
    if(nextIndex < 0) {
        value = url.substring(equalIndex + 1);
    } else {
        value = url.substring(equalIndex + 1, nextIndex);
    }
    return value;
}
