Qt.include("script/settings.js")

var isRetry = false;

// Called when the server responds to the fetch details call
function cbFetchNews(xml, text) {
    if(xml === null) {
        if(isRetry) {
            errorTextDetailsView.opacity = 1;
            isRetry = false;
            if(busyIndicator)
                busyIndicator.opacity = 0;

            return;
        }
        isRetry = true;
        fetchNews(newsId);
        return;
    }

    isRetry = false;

    errorTextDetailsView.opacity = 0;

    newsDetailPage.newsId = newsId = CommonScript.getElementsByTagName(
            xml.documentElement, "id")[0].firstChild.nodeValue;

    parseNewsData(xml);
}

function parseNewsData(xml) {
    var title = CommonScript.getElementsByTagName(
            xml.documentElement, "title")[0].firstChild.nodeValue;
    newsTitle.text = title;

    newsDetailPage.newsTitle = title;

    var author = CommonScript.getElementsByTagName(
            xml.documentElement, "author")[0].firstChild.nodeValue;
    newsAuthor.text = author;

    var date = CommonScript.getElementsByTagName(
            xml.documentElement, "pubDate")[0].firstChild.nodeValue;
    newsDate.text = nokioteca.getPrettyDate(date);

    try {
        var thumb = CommonScript.getElementsByTagName(
            xml.documentElement, "thumb")[0].firstChild.nodeValue;
        newsDetailPage.newsThumb = thumb;
    } catch(err) {}

    try {
        var wk = CommonScript.getElementsByTagName(
            xml.documentElement, "wk")[0].firstChild.nodeValue;
        if(wk === "true")
            wkWatermarkLoader.show();
    } catch(err) {}
    
    try {
        var commentsEnabled = CommonScript.getElementsByTagName(
            xml.documentElement, "commentsEnabled")[0].firstChild.nodeValue;

        if(commentsEnabled === "false")
            newsDetailPage.commentsEnabled = false;
    } catch(err) {}
    
    newsDetailPage.commentsEnabled = settings.commentsUniversalEnabled && newsDetailPage.commentsEnabled;
    
    var overview1 = CommonScript.getElementsByTagName(
                xml.documentElement, "description")[0].firstChild.nodeValue.trim();

    var overview2;

    // Remove objects from the HTML code.
    var objectStartInd = 0;

    // Sistemo i downloads
    var i = 0;
    var downloadIds = [];
    while((objectStartInd = overview1.indexOf("[download ", objectStartInd)) !== -1) {
        var objectEndInd = overview1.indexOf("]", objectStartInd) + 1;
        if(!isWindowsteca) {
            downloadIds[i] = treatDownload(overview1.substring(objectStartInd, objectEndInd));
            i++;
        }
        overview1 = overview1.substring(0, objectStartInd) + overview1.substring(objectEndInd);
    }

    newsDetailPage.downloadIds = downloadIds;
    if(downloadIds.length > 0)
        downloadHelperLoader.show();

    // Sistemo i video youtube
    while((objectStartInd = overview1.indexOf("[youtube]", objectStartInd)) !== -1) {
        objectEndInd = overview1.indexOf("[/youtube]", objectStartInd);
        var imageUrl = overview1.substring(objectStartInd + "[youtube]".length, objectEndInd).trim();

        overview1 = overview1.substring(0, objectStartInd).trim() + "<a href=\"youtube://" + imageUrl.substring(imageUrl.length - 11) + "\">" +
                "<table border=\"0\" cellspacing=\"5\"><tr>" +
                "<td><#img src=\"" + Qt.resolvedUrl("qrc:/images/youtube.png") + "\" /></td>" +
                "<td>Video</td></tr></table></a>" + overview1.substring(objectEndInd + "[/youtube]".length).trim();
    }

    // Sistemo i video vimeo
    while((objectStartInd = overview1.indexOf("[vimeo]", objectStartInd)) !== -1) {
        objectEndInd = overview1.indexOf("[/vimeo]", objectStartInd);
        imageUrl = overview1.substring(objectStartInd + "[vimeo]".length, objectEndInd);

        overview1 = overview1.substring(0, objectStartInd).trim() + "<a href=\"" + imageUrl + "\">" + "<table border=\"0\" cellspacing=\"5\"><tr>" +
                "<td><#img src=\"" + Qt.resolvedUrl("qrc:/images/vimeo.png") + "\" /></td>" +
                "<td>Video</td></tr></table></a>" + overview1.substring(objectEndInd + "[/vimeo]".length).trim();
    }

    // Sistemo i video viddler
    while((objectStartInd = overview1.indexOf("[viddler id=", objectStartInd)) !== -1) {
        objectEndInd = overview1.indexOf("&w=", objectStartInd);
        imageUrl = overview1.substring(objectStartInd + "[viddler id=".length, objectEndInd);

        overview1 = overview1.substring(0, objectStartInd).trim() + "<a href=\"http://www.viddler.com/embed/" + imageUrl + "\">" +
                "<table border=\"0\" cellspacing=\"5\"><tr>" +
                "<td><#img src=\"" + Qt.resolvedUrl("qrc:/images/viddler.png") + "\" /></td>" +
                "<td>Video</td></tr></table></a>" + overview1.substring(overview1.indexOf("]", objectEndInd)).trim();
    }
    
    // Rimuovo i caption con relative immagini
    while((objectStartInd = overview1.indexOf("[caption", objectStartInd)) !== -1) {
        objectEndInd = overview1.indexOf("[/caption]", objectStartInd) + "[/caption]".length;
        imageUrl = treatLinksOnCaption(overview1.substring(objectStartInd, objectEndInd));

        if(imageUrl.length !== 0) {
            overview1 = overview1.substring(0, objectStartInd).trim() + imageUrl +
                        overview1.substring(objectEndInd).trim();
            objectStartInd += imageUrl.trim().length;
        }
        else {
            objectStartInd = objectEndInd;
        }
    }

    // Sistemo i link con relative immagini
    while((objectStartInd = overview1.indexOf("<a ", objectStartInd)) !== -1) {
        objectEndInd = overview1.indexOf("</a>", objectStartInd) + "</a>".length;
        imageUrl = treatLinks(overview1.substring(objectStartInd, objectEndInd));

        if(imageUrl.length !== 0) {
            overview1 = overview1.substring(0, objectStartInd).trim() + imageUrl +
                        overview1.substring(objectEndInd).trim();
            objectStartInd += imageUrl.length;
        }
        else {
            objectStartInd = objectEndInd;
        }
    }

    // Sistemo eventuali altre immagini
    while((objectStartInd = overview1.indexOf("<img ", objectStartInd)) !== -1) {
        objectEndInd = overview1.indexOf("/>", objectStartInd) + "/>".length;
        imageUrl = treatLinks(overview1.substring(objectStartInd, objectEndInd));

        overview1 = overview1.substring(0, objectStartInd).trim() + imageUrl +
                    overview1.substring(objectEndInd).trim();

        objectStartInd += imageUrl.length;
    }

    // Sistemo le gallery eventuali
    galleryModel.clear();
    var firstGalleryStart = -1;
    while((objectStartInd = overview1.indexOf("[gallery", objectStartInd)) !== -1) {
        objectEndInd = overview1.indexOf("]", objectStartInd) + 1;
        treatGallery(xml.documentElement, overview1.substring(objectStartInd, objectEndInd))

        if(firstGalleryStart === -1)
            firstGalleryStart = overview1.substring(0, objectStartInd).length;

        overview1 = overview1.substring(0, objectStartInd) + overview1.substring(objectEndInd);
    }
    if(galleryModel.count !== 0) {
        secondPartOverviewLoader.show();
        overview2 = overview1.substring(firstGalleryStart).trim();
        overview1 = overview1.substring(0, firstGalleryStart).trim();
    }

    overview1 = overview1.trim().replace(new RegExp("<#img", 'g'), "<img");

    newsOverview1.text = "<div>" + overview1.replace(/(\r\n|\n|\r){2}/gm, "<br/><br/>") + "</div>";

    if(overview2 && overview2.trim().length > 0) {
        overview2 = overview2.trim().replace(new RegExp("<#img", 'g'), "<img");
        secondPartOverviewLoader.setSecondPartOverviewText("<div>" + overview2.replace(/(\r\n|\n|\r){2}/gm, "<br/><br/>") + "</div>");
    }

    if(busyIndicator)
        busyIndicator.opacity = 0;

        openNewsContent.restart();
}

function treatLinksOnCaption(theLink) {
    var startImg = theLink.indexOf("<img ");
    if(startImg === -1)
        return "";

    var imageWidth = getImageWidth(theLink.substring(startImg));

    startImg = theLink.indexOf(" href");
    startImg = theLink.indexOf("\"", startImg) + 1;
    var bigImgUrl = theLink.substring(startImg, theLink.indexOf("\"", startImg));

    startImg = theLink.indexOf(" src", startImg);
    startImg = theLink.indexOf("\"", startImg) + 1;

    var imgUrl = theLink.substring(startImg, theLink.indexOf("\"", startImg));

    if(bigImgUrl.indexOf(".jpg") === -1 && bigImgUrl.indexOf(".jpeg") === -1 &&
            bigImgUrl.indexOf(".png") === -1 && bigImgUrl.indexOf(".gif") === -1)
        bigImgUrl = imgUrl;

    if(theLink.indexOf("alignright") !== -1 || theLink.indexOf("alignleft") !== -1)
        imgUrl= " <a href=\"img://" + bigImgUrl + "\"><#img src=\"" + imgUrl + "\" width=\"" +
                Math.min(175, imageWidth) +
                "\" style=\"float: right\" /></a> ";
    else
        imgUrl= " \n\n<center><a href=\"img://" + bigImgUrl + "\"><#img src=\"" + imgUrl + "\" width=\"" +
                Math.min((newsOverview1.width - 10), imageWidth) +
                "\" /></a></center>\n\n ";

    return imgUrl;
}

function treatLinks(theLink) {
    var startImg = theLink.indexOf("<img ");
    if(startImg === -1)
        return "";

    var imageWidth = getImageWidth(theLink.substring(startImg));

    startImg = theLink.indexOf(" src", startImg);
    startImg = theLink.indexOf("\"", startImg) + 1;

    var imgUrl = theLink.substring(startImg, theLink.indexOf("\"", startImg));

    if(theLink.indexOf("alignright") !== -1 || theLink.indexOf("alignleft") !== -1)
        imgUrl= " <a href=\"img://" + imgUrl + "\"><#img src=\"" + imgUrl + "\" width=\"" +
                Math.min(175, imageWidth) +
                "\" style=\"float: right\" /></a> ";
    else
        imgUrl= " \n\n<center><a href=\"img://" + imgUrl + "\"><#img src=\"" + imgUrl + "\" width=\"" +
                Math.min((newsOverview1.width - 10), imageWidth) +
                "\" /></a></center>\n\n ";

    return imgUrl;
}

function getImageWidth(theLink) {
    var startImg = theLink.indexOf(" width");
    if(startImg === -1)
        return 175;

    startImg = theLink.indexOf("\"", startImg) + 1 ;
    return theLink.substring(startImg, theLink.indexOf("\"", startImg));
}

function treatGallery(xmlDocument, theGallery) {
    var excludedPics;
    var toExclude = theGallery.indexOf("exclude");

    if(toExclude !== -1) {
        toExclude = theGallery.indexOf("\"", toExclude) + 1;
        excludedPics = theGallery.substring(toExclude, theGallery.indexOf("\"", toExclude)).split(",");
    }

    var links = CommonScript.getElementsByTagName(xmlDocument, "links");

    var childNodes = links[0].childNodes;
    for(var i = childNodes.length - 1; i >= 0; i--) {
        var theId = CommonScript.getAttributeValue(childNodes[i], "id");
        if(!theId || isToExclude(theId, excludedPics))
            continue;

        galleryModel.append({"thumbUrl": CommonScript.getAttributeValue(childNodes[i], "thumb"),
                                "picUrl": CommonScript.getAttributeValue(childNodes[i], "full")});
    }

    return true;
}

function isToExclude(theId, theExcluded) {
    if(theExcluded) {
        for(var i = 0; i < theExcluded.length; i++) {
            if(theId === theExcluded[i])
                return true;
        }
    }
    return false;
}

function treatDownload(theDownload) {
    var startId = theDownload.indexOf("id");
    startId = theDownload.indexOf("\"", startId) + 1;
    return theDownload.substring(startId, theDownload.indexOf("\"", startId));
}

function handleYoutubeVideo(videoId) {
    if(busyIndicator)
        busyIndicator.opacity = 1;

    switch(getSelectedVideoType()) {
        case 1: {
            makeYoutubeRTSPRequest(videoId);
            break;
        }
        case 2: {
            Qt.openUrlExternally("http://youtu.be/" + videoId + "?hd=1");
            if(busyIndicator)
                busyIndicator.opacity = 0;
            break;
        }
        case 3: {
            videoTypeModel.clear();
            videoTypeModel.append({"modelData": "Nell'applicazione (bassa qualità)",
                                      "videoId": videoId});
            videoTypeModel.append({"modelData": "Nel browser web",
                                      "videoId": videoId});

            videoTypeDialogLoader.show();
            if(busyIndicator)
                busyIndicator.opacity = 0;
            break;
        }
    }

    return;
}

function makeYoutubeRTSPRequest(videoId) {
    if(busyIndicator)
        busyIndicator.opacity = 1;

    var req = AjaxScript.createXMLHttpRequest();

    if(req) {
        var url = "http://gdata.youtube.com/feeds/mobile/videos/" + videoId + "?v=2"
        AjaxScript.loadXMLDocSync(req, url, getYoutubeVideoRTSP);
    }
}

function getYoutubeVideoRTSP(xml, text) {
    if(xml === null) {
        if(busyIndicator)
            busyIndicator.opacity = 0;
        return;
    }

    var mediaGroup = CommonScript.getElementsByTagName(xml.documentElement, "group")[0];

    mediaGroup = CommonScript.getElementsByTagName(mediaGroup, "content");

    for(var i = 0; i < mediaGroup.length; i++) {
        if(CommonScript.getAttributeValue(mediaGroup[i], "format") === "6") {
            Qt.openUrlExternally(CommonScript.getAttributeValue(mediaGroup[i], "url"));
            break;
        }
    }

    if(busyIndicator)
        busyIndicator.opacity = 0;
}

function manageLinkOnNews(link) {
    if(link.indexOf("youtube://") === 0) {
        SingleNewsOverviewTabFn.handleYoutubeVideo(link.substring(10));
        return;
    }
    if(link.indexOf("img://") === 0) {
        zoomedImageLoader.show(link.substring(6));
        return;
    }

    if((link.indexOf("www.nokioteca.net/blog/") >= 0 || link.indexOf("www.windowsteca.net/") >= 0) &&
            link.indexOf("#comment") < 0 && link.indexOf("forum") < 0 && link.length > 40) {
        if(busyIndicator)
            busyIndicator.opacity = 1;
        if(!newsDetailPage.pageStack.busy) {
            link = encodeURIComponent(link);
            var detailsPage =
                    newsDetailPage.pageStack.push(Qt.resolvedUrl("SingleNewsPage.qml"),
                                              { newsId: link, 
                                                commentsCount: 0,
                                                isWindowsteca: (link.indexOf("windowsteca") >= 0)
                                              });
            detailsPage.fetchDetails(link);
        }
        return;
    }

    Qt.openUrlExternally(link);
}
